Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4108)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4109)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! - Separate initialization of advection flags for momentum and scalars.
+! - Change subroutine interface for ws_init_flags_scalar to pass boundary flags
 ! 
 ! Former revisions:
@@ -373,5 +374,5 @@
  
     USE advec_ws,                                                              &
-        ONLY:  ws_init_flags
+        ONLY:  ws_init_flags_momentum, ws_init_flags_scalar
 
     USE arrays_3d,                                                             &
@@ -380,4 +381,12 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc,                                           &
+               bc_dirichlet_l,                                                 &
+               bc_dirichlet_n,                                                 &
+               bc_dirichlet_r,                                                 &
+               bc_dirichlet_s,                                                 &
+               bc_radiation_l,                                                 &
+               bc_radiation_n,                                                 &
+               bc_radiation_r,                                                 &
+               bc_radiation_s,                                                 &
                constant_flux_layer, dz, dz_max, dz_stretch_factor,             &
                dz_stretch_factor_array, dz_stretch_level, dz_stretch_level_end,&
@@ -392,5 +401,7 @@
         
     USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
+        ONLY:  advc_flags_m,                                                   &
+               advc_flags_s,                                                   &
+               nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
                nzb, nzb_diff, nzb_diff_s_inner, nzb_diff_s_outer,              &
                nzb_max, nzb_s_inner, nzb_s_outer, nzb_u_inner,                 &
@@ -845,11 +856,25 @@
 !-- Calculate wall flag arrays for the multigrid method.
 !-- Please note, wall flags are only applied in the non-optimized version.
-    IF ( psolver == 'multigrid_noopt' )  CALL poismg_noopt_init 
+    IF ( psolver == 'multigrid_noopt' )  CALL poismg_noopt_init
 
 !
 !-- Init flags for ws-scheme to degrade order of the numerics near walls, i.e. 
-!-- to decrease the numerical stencil appropriately.
-    IF ( momentum_advec == 'ws-scheme'  .OR.  scalar_advec == 'ws-scheme' )    &
-       CALL ws_init_flags
+!-- to decrease the numerical stencil appropriately. The order of the scheme
+!-- is degraded near solid walls as well as near non-cyclic inflow and outflow
+!-- boundaries. Do this separately for momentum and scalars.
+    IF ( momentum_advec == 'ws-scheme' )  THEN
+       ALLOCATE( advc_flags_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL ws_init_flags_momentum
+    ENDIF
+    IF ( scalar_advec == 'ws-scheme'   )  THEN
+       ALLOCATE( advc_flags_s(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       advc_flags_s = 0
+       
+       CALL ws_init_flags_scalar( bc_dirichlet_l  .OR.  bc_radiation_l,        &
+                                  bc_dirichlet_n  .OR.  bc_radiation_n,        &
+                                  bc_dirichlet_r  .OR.  bc_radiation_r,        &
+                                  bc_dirichlet_s  .OR.  bc_radiation_s,        &
+                                  advc_flags_s )
+    ENDIF
 
 !
@@ -861,6 +886,5 @@
        DO  j = nys, nyn
           DO  k = nzb, nzt + 1
-             k_top = MAX( k_top, MERGE( k, 0,                                  &
-                                        .NOT. BTEST( topo(k,j,i), 0 ) ) )
+             k_top = MAX( k_top, MERGE( k, 0, .NOT. BTEST( topo(k,j,i), 0 ) ) )
           ENDDO
        ENDDO
@@ -2496,5 +2520,5 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc, constant_flux_layer, land_surface,        &
-               use_surface_fluxes, use_top_fluxes, urban_surface
+               scalar_advec, use_surface_fluxes, use_top_fluxes, urban_surface
 
     USE indices,                                                               &
@@ -2724,4 +2748,32 @@
           wall_flags_0(nzt+1,j,i) = IBSET( wall_flags_0(nzt+1,j,i), 22 )
           wall_flags_0(nzt+1,j,i) = IBSET( wall_flags_0(nzt+1,j,i), 23 )
+!
+!--       Set flags indicating that topography is close by in horizontal 
+!--       direction, i.e. flags that infold the topography. These will be used
+!--       to set advection flags for passive scalars, where due to large 
+!--       gradients near buildings stationary numerical oscillations can produce 
+!--       unrealistically high concentrations. This is only necessary if 
+!--       WS-scheme is applied for scalar advection. Note, these flags will be 
+!--       only used for passive scalars such as chemical species or aerosols.
+          IF ( scalar_advec == 'ws-scheme' )  THEN
+             DO k = nzb, nzt
+                IF ( BTEST( wall_flags_0(k,j,i), 0 )  .AND. (                   &
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-3:j+3,i-1), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-3:j+3,i-2), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-3:j+3,i-3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-3:j+3,i+1), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-3:j+3,i+2), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-3:j+3,i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-1,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-2,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j-3,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j+1,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j+2,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_0(k,j+3,i-3:i+3), 0 ) )      &
+                                                            ) )                &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 31 )
+                     
+             ENDDO
+          ENDIF
        ENDDO
     ENDDO
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4108)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4109)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! Relax checks for non-consistent initialization in case static or dynamic 
+! input is provided. For example, soil_temperature or deep_soil_temperature
+! is not mandatory any more if dynamic input is available. Also, improper 
+! settings of x_type in namelist are only checked if no static file is 
+! available. 
 ! 
 ! Former revisions:
@@ -591,5 +595,7 @@
 
     USE netcdf_data_input_mod,                                                 &
-        ONLY :  building_type_f, init_3d, input_pids_static,                   &
+        ONLY :  building_type_f, init_3d,                                      &
+                input_pids_dynamic,                                            &
+                input_pids_static,                                             &
                 netcdf_data_input_interpolate, netcdf_data_input_init_lsm,     &
                 pavement_pars_f, pavement_subsurface_pars_f, pavement_type_f,  &
@@ -727,5 +733,5 @@
                                    soil_temperature = 9999999.9_wp,  & !< NAMELIST soil temperature (K) +1
                                    dz_soil  = 9999999.9_wp,          & !< (NAMELIST) soil layer depths (spacing)
-                                   zs_layer = 9999999.9_wp         !< soil layer depths (edge)
+                                   zs_layer = 9999999.9_wp             !< soil layer depths (edge)
                                  
     TYPE(surf_type_lsm), POINTER ::  t_soil_h,    & !< Soil temperature (K), horizontal surface elements
@@ -1437,6 +1443,5 @@
 !-- Check if soil types are set within a valid range.
     IF ( TRIM( surface_type ) == 'vegetation'  .OR.                            &
-         TRIM( surface_type ) == 'pavement'    .OR.                            &
-         TRIM( surface_type ) == 'netcdf' )  THEN
+         TRIM( surface_type ) == 'pavement' )  THEN
        IF ( soil_type < LBOUND( soil_pars, 2 )  .AND.                          &
             soil_type > UBOUND( soil_pars, 2 ) )  THEN
@@ -1445,4 +1450,6 @@
           CALL message( 'lsm_check_parameters', 'PA0452', 2, 2, 0, 6, 0 )
        ENDIF
+    ENDIF
+    IF ( TRIM( surface_type ) == 'netcdf' )  THEN
        IF ( soil_type_f%from_file )  THEN
           DO  i = nxl, nxr
@@ -1462,6 +1469,5 @@
 !
 !-- Check if vegetation types are set within a valid range.    
-    IF ( TRIM( surface_type ) == 'vegetation'  .OR.                            &
-         TRIM( surface_type ) == 'netcdf' )  THEN
+    IF ( TRIM( surface_type ) == 'vegetation' )  THEN
        IF ( vegetation_type < LBOUND( vegetation_pars, 2 )  .AND.              &
             vegetation_type > UBOUND( vegetation_pars, 2 ) )  THEN
@@ -1470,4 +1476,6 @@
           CALL message( 'lsm_check_parameters', 'PA0526', 2, 2, 0, 6, 0 )
        ENDIF
+    ENDIF
+    IF ( TRIM( surface_type ) == 'netcdf' )  THEN
        IF ( vegetation_type_f%from_file )  THEN
           DO  i = nxl, nxr
@@ -1488,6 +1496,5 @@
 !
 !-- Check if pavement types are set within a valid range.    
-    IF ( TRIM( surface_type ) == 'pavement'  .OR.                              &
-         TRIM( surface_type ) == 'netcdf' )  THEN
+    IF ( TRIM( surface_type ) == 'pavement' )  THEN
        IF ( pavement_type < LBOUND( pavement_pars, 2 )  .AND.                  &
             pavement_type > UBOUND( pavement_pars, 2 ) )  THEN
@@ -1496,4 +1503,6 @@
           CALL message( 'lsm_check_parameters', 'PA0527', 2, 2, 0, 6, 0 )
        ENDIF
+    ENDIF
+    IF ( TRIM( surface_type ) == 'netcdf' )  THEN
        IF ( pavement_type_f%from_file )  THEN
           DO  i = nxl, nxr
@@ -1513,6 +1522,5 @@
 !
 !-- Check if water types are set within a valid range.    
-    IF ( TRIM( surface_type ) == 'water'  .OR.                                 &
-         TRIM( surface_type ) == 'netcdf' )  THEN
+    IF ( TRIM( surface_type ) == 'water' )  THEN
        IF ( water_type < LBOUND( water_pars, 2 )  .AND.                        &
             water_type > UBOUND( water_pars, 2 ) )  THEN
@@ -1521,4 +1529,6 @@
           CALL message( 'lsm_check_parameters', 'PA0528', 2, 2, 0, 6, 0 )
        ENDIF
+    ENDIF
+    IF ( TRIM( surface_type ) == 'netcdf' )  THEN
        IF ( water_type_f%from_file )  THEN
           DO  i = nxl, nxr
@@ -1708,5 +1718,5 @@
 !
 !-- Temporary message as long as NetCDF input is not available
-    IF ( TRIM( surface_type ) == 'netcdf'  .AND.  .NOT.  input_pids_static )   &
+    IF ( TRIM( surface_type ) == 'netcdf'  .AND.  .NOT. input_pids_static )   &
     THEN
        message_string = 'surface_type = netcdf requires static input file.'
@@ -1714,5 +1724,5 @@
     ENDIF
 
-    IF ( soil_type == 0 )  THEN
+    IF ( soil_type == 0  .AND.  .NOT. input_pids_static )  THEN
 
        IF ( alpha_vangenuchten == 9999999.9_wp )  THEN
@@ -1796,16 +1806,19 @@
 !
 !-- Check whether valid soil temperatures are prescribed
-    IF ( COUNT( soil_temperature /= 9999999.9_wp ) /= nzs )  THEN
-       WRITE( message_string, * ) 'number of soil layers (', nzs, ') does not',&
+    IF ( .NOT. input_pids_dynamic )  THEN
+       IF ( COUNT( soil_temperature /= 9999999.9_wp ) /= nzs )  THEN
+          WRITE( message_string, * )                                           &
+                                  'number of soil layers (', nzs, ') does not',&
                                   ' match to the number of layers specified',  &
                                   ' in soil_temperature (', COUNT(             &
-                                   soil_temperature /= 9999999.9_wp ), ')'
-          CALL message( 'lsm_check_parameters', 'PA0471', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( deep_soil_temperature == 9999999.9_wp ) THEN
-          message_string = 'deep_soil_temperature is not set but must be'//    &
-                           '/= 9999999.9'
-          CALL message( 'lsm_check_parameters', 'PA0472', 1, 2, 0, 6, 0 )
+                                  soil_temperature /= 9999999.9_wp ), ')'
+             CALL message( 'lsm_check_parameters', 'PA0471', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       IF ( deep_soil_temperature == 9999999.9_wp ) THEN
+             message_string = 'deep_soil_temperature is not set but must be'// &
+                              '/= 9999999.9'
+             CALL message( 'lsm_check_parameters', 'PA0472', 1, 2, 0, 6, 0 )
+       ENDIF
     ENDIF
 
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 4108)
+++ /palm/trunk/SOURCE/modules.f90	(revision 4109)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! -advc_flags_1, advc_flags_2
+! +advc_flags_m, advc_flags_s
 ! 
 ! Former revisions:
@@ -1744,6 +1745,6 @@
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_10  !< topograpyh masking flag on multigrid level 10 
 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_1            !< flags used to degrade order of advection scheme
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_2            !< flags used to degrade order of advection scheme
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_m            !< flags used to degrade order of advection scheme for momentum
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_s            !< flags used to degrade order of advection scheme for scalar quantities
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_0            !< flags to mask topography and surface-bounded grid points
 
Index: /palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- /palm/trunk/SOURCE/ocean_mod.f90	(revision 4108)
+++ /palm/trunk/SOURCE/ocean_mod.f90	(revision 4109)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Pass integer flag array as well as boundary flags to WS scalar advection 
+! routine
 ! 
 ! Former revisions:
@@ -1582,5 +1583,13 @@
 
     USE control_parameters,                                                    &
-        ONLY:  dt_3d, intermediate_timestep_count,                             &
+        ONLY:  bc_dirichlet_l,                                                 &
+               bc_dirichlet_n,                                                 &
+               bc_dirichlet_r,                                                 &
+               bc_dirichlet_s,                                                 &
+               bc_radiation_l,                                                 &
+               bc_radiation_n,                                                 &
+               bc_radiation_r,                                                 &
+               bc_radiation_s,                                                 &
+               dt_3d, intermediate_timestep_count,                             &
                intermediate_timestep_count_max, scalar_advec, simulated_time,  &
                timestep_scheme, tsc, ws_scheme_sca
@@ -1593,5 +1602,5 @@
 
     USE indices,                                                               &
-        ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
+        ONLY:  advc_flags_s, nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
 
     USE surface_mod,                                                           &
@@ -1647,5 +1656,9 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( sa, 'sa' )
+                CALL advec_s_ws( advc_flags_s, sa, 'sa',                       &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( sa )
@@ -1745,5 +1758,13 @@
 
     USE control_parameters,                                                    &
-        ONLY:  dt_3d, intermediate_timestep_count,                             &
+        ONLY:  bc_dirichlet_l,                                                 &
+               bc_dirichlet_n,                                                 &
+               bc_dirichlet_r,                                                 &
+               bc_dirichlet_s,                                                 &
+               bc_radiation_l,                                                 &
+               bc_radiation_n,                                                 &
+               bc_radiation_r,                                                 &
+               bc_radiation_s,                                                 &
+               dt_3d, intermediate_timestep_count,                             &
                intermediate_timestep_count_max, simulated_time,                &
                timestep_scheme, tsc, ws_scheme_sca
@@ -1753,5 +1774,5 @@
 
     USE indices,                                                               &
-        ONLY:  nzb, nzt, wall_flags_0
+        ONLY:  advc_flags_s, nzb, nzt, wall_flags_0
 
     USE surface_mod,                                                           &
@@ -1790,6 +1811,11 @@
        THEN
           IF ( ws_scheme_sca )  THEN
-             CALL advec_s_ws( i, j, sa, 'sa', flux_s_sa,  diss_s_sa, flux_l_sa,&
-                              diss_l_sa, i_omp_start, tn  )
+             CALL advec_s_ws( advc_flags_s,                                    &
+                              i, j, sa, 'sa', flux_s_sa,  diss_s_sa, flux_l_sa,&
+                              diss_l_sa, i_omp_start, tn,                      &
+                              bc_dirichlet_l  .OR.  bc_radiation_l,            &
+                              bc_dirichlet_n  .OR.  bc_radiation_n,            &
+                              bc_dirichlet_r  .OR.  bc_radiation_r,            &
+                              bc_dirichlet_s  .OR.  bc_radiation_s )
           ELSE
              CALL advec_s_pw( i, j, sa )
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 4108)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 4109)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! pass integer flag array to WS scalar advection routine which is now necessary
+! as the flags may differ for scalars, e.g. pt can be cyclic while chemical
+! species may be non-cyclic. Further, pass boundary flags. 
 ! 
 ! Former revisions:
@@ -420,5 +422,13 @@
 
     USE control_parameters,                                                    &
-        ONLY:  constant_diffusion,                                             &
+        ONLY:  bc_dirichlet_l,                                                 &
+               bc_dirichlet_n,                                                 &
+               bc_dirichlet_r,                                                 &
+               bc_dirichlet_s,                                                 &
+               bc_radiation_l,                                                 &
+               bc_radiation_n,                                                 &
+               bc_radiation_r,                                                 &
+               bc_radiation_s,                                                 &
+               constant_diffusion,                                             &
                debug_output_timestep,                                          &
                dp_external, dp_level_ind_b, dp_smooth_factor, dpdxy, dt_3d,    &
@@ -454,5 +464,6 @@
 
     USE indices,                                                               &
-        ONLY:  nbgp, nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv,   &
+        ONLY:  advc_flags_s,                                                   &
+               nbgp, nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv,   &
                nzb, nzt, wall_flags_0
 
@@ -805,6 +816,11 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( ws_scheme_sca )  THEN
-                      CALL advec_s_ws( i, j, pt, 'pt', flux_s_pt, diss_s_pt,   &
-                                       flux_l_pt, diss_l_pt, i_omp_start, tn )
+                      CALL advec_s_ws( advc_flags_s,                           &
+                                       i, j, pt, 'pt', flux_s_pt, diss_s_pt,   &
+                                       flux_l_pt, diss_l_pt, i_omp_start, tn,  &
+                                       bc_dirichlet_l  .OR.  bc_radiation_l,   &
+                                       bc_dirichlet_n  .OR.  bc_radiation_n,   &
+                                       bc_dirichlet_r  .OR.  bc_radiation_r,   &
+                                       bc_dirichlet_s  .OR.  bc_radiation_s )
                    ELSE
                       CALL advec_s_pw( i, j, pt )
@@ -899,9 +915,15 @@
 !--          Tendency-terms for total water content / scalar
              tend(:,j,i) = 0.0_wp
-             IF ( timestep_scheme(1:5) == 'runge' ) &
+             IF ( timestep_scheme(1:5) == 'runge' )                            &
              THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( i, j, q, 'q', flux_s_q, &
-                                diss_s_q, flux_l_q, diss_l_q, i_omp_start, tn )
+                   CALL advec_s_ws( advc_flags_s,                              &
+                                    i, j, q, 'q', flux_s_q,                    &
+                                    diss_s_q, flux_l_q, diss_l_q,              &
+                                    i_omp_start, tn,                           &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( i, j, q )
@@ -983,5 +1005,5 @@
 !--          Tendency-terms for total water content / scalar
              tend(:,j,i) = 0.0_wp
-             IF ( timestep_scheme(1:5) == 'runge' ) &
+             IF ( timestep_scheme(1:5) == 'runge' )                            &
              THEN
                 IF ( ws_scheme_sca )  THEN
@@ -989,7 +1011,13 @@
 !--                For scalar advection apply monotonic flux limiter near 
 !--                topography.
-                   CALL advec_s_ws( i, j, s, 's', flux_s_s, &
+                   CALL advec_s_ws( advc_flags_s,                              &
+                                    i, j, s, 's', flux_s_s,                    &
                                     diss_s_s, flux_l_s, diss_l_s, i_omp_start, &
-                                    tn, monotonic_limiter_z )
+                                    tn,                                        &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s,      &
+                                    monotonic_limiter_z )
                 ELSE
                    CALL advec_s_pw( i, j, s )
@@ -1437,5 +1465,9 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( pt, 'pt' )
+                CALL advec_s_ws( advc_flags_s, pt, 'pt',                       &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( pt )
@@ -1573,5 +1605,9 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( q, 'q' )
+                CALL advec_s_ws( advc_flags_s, q, 'q',                         &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( q )
@@ -1687,5 +1723,9 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( s, 's' )
+                CALL advec_s_ws( advc_flags_s, s, 's',                         &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( s )
Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 4108)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 4109)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Pass integer flag array as well as boundary flags to WS scalar advection 
+! routine
 ! 
 ! Former revisions:
@@ -7739,5 +7740,5 @@
 
     USE indices,                                                                                   &
-        ONLY:  wall_flags_0
+        ONLY:  advc_flags_s, wall_flags_0
 
     USE pegrid,                                                                                    &
@@ -7782,5 +7783,10 @@
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_sca )  THEN
-          CALL advec_s_ws( i, j, rs, id, flux_s, diss_s, flux_l, diss_l, i_omp_start, tn,          &
+          CALL advec_s_ws( advc_flags_s, i, j, rs, id, flux_s, diss_s, flux_l, diss_l,             &
+                           i_omp_start, tn,                                                        &
+                           bc_dirichlet_l  .OR.  bc_radiation_l,                                   &
+                           bc_dirichlet_n  .OR.  bc_radiation_n,                                   &
+                           bc_dirichlet_r  .OR.  bc_radiation_r,                                   &
+                           bc_dirichlet_s  .OR.  bc_radiation_s,                                   &
                            monotonic_limiter_z )
        ELSE
@@ -7883,5 +7889,5 @@
         ONLY:  diffusion_s
     USE indices,                                                                                   &
-        ONLY:  wall_flags_0
+        ONLY:  advc_flags_s, wall_flags_0
     USE surface_mod,                                                                               &
         ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
@@ -7914,5 +7920,9 @@
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_sca )  THEN
-          CALL advec_s_ws( rs, id )
+          CALL advec_s_ws( advc_flags_s, rs, id,                                                   &
+                           bc_dirichlet_l  .OR.  bc_radiation_l,                                   &
+                           bc_dirichlet_n  .OR.  bc_radiation_n,                                   &
+                           bc_dirichlet_r  .OR.  bc_radiation_r,                                   &
+                           bc_dirichlet_s  .OR.  bc_radiation_s )
        ELSE
           CALL advec_s_pw( rs )
